
QGIS Application - Bug report #16369

Filter query on WFS layer doesn't work

2017-03-21 02:04 AM - Stefan Rey

Status: Closed

Priority: Normal

Assignee:

Category: Unknown

Affected QGIS version:2.18.4 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: invalid

Crashes QGIS or corrupts data:No Copied to github as #: 24279

Description

I tried it with QGIS 2.18.4-1 as well as 2.99.0-32 (nightly build), both with the same behaviour. I wanted to add a WFS point layer. The

WFS I use is https://geodienste.ch/db/av , I added for example the layer 'Einzelobjekte (Punkte)'. That works fine so far.

Now I want to add a filter on this specific layer. The query I placed in the query builder is "Kanton" = 'BE'. The feature count is now

reduzed, but the all the features displayed in the map disappear.

I also tried to make the query adding the WFS layer (see printscreen). The layer is added, but no feature is displayed in the map.

History

#1 - 2017-05-01 01:01 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#2 - 2017-09-22 09:53 AM - Jürgen Fischer

- Category set to Unknown

#3 - 2018-05-31 08:59 PM - Even Rouault

- Resolution set to invalid

- Description updated

Ater investigation, this is an issue with the WFS server itself, where spatial + attribute filter fail (I tried all 3 WFS version=

For example

https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=2.0.0&#38;TYPENAMES=ms:SOPT&#38;STARTINDE

=0&#38;COUNT=1000&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cfes:Filter xmlns:fes%3D%22http://www.opengis.net/fes/2.0%22

xmlns:gml%3D%22http://www.opengis.net/gml/3.2%22%3E%0A %3Cfes:And%3E%0A %3Cfes:BBOX%3E%0A

%3Cfes:ValueReference%3EmsGeometry%3C/fes:ValueReference%3E%0A %3Cgml:Envelope

srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A %3Cgml:lowerCorner%3E2427790 1059290%3C/gml:lowerCorner%3E%0A

%3Cgml:upperCorner%3E2886430 1310890%3C/gml:upperCorner%3E%0A %3C/gml:Envelope%3E%0A %3C/fes:BBOX%3E%0A

%3Cfes:PropertyIsEqualTo xmlns:fes%3D%22http://www.opengis.net/fes/2.0%22%3E%0A

%3Cfes:ValueReference%3EKanton%3C/fes:ValueReference%3E%0A %3Cfes:Literal

xmlns:fes%3D%22http://www.opengis.net/fes/2.0%22%3EBE%3C/fes:Literal%3E%0A %3C/fes:PropertyIsEqualTo%3E%0A

%3C/fes:And%3E%0A%3C/fes:Filter%3E%0A

returns the following error
https://geodienste.ch/db/av
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=2.0.0&#38;TYPENAMES=ms:SOPT&#38;STARTINDEX=0&#38;COUNT=1000&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cfes:Filter
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=2.0.0&#38;TYPENAMES=ms:SOPT&#38;STARTINDEX=0&#38;COUNT=1000&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cfes:Filter


<ows:ExceptionReport version="2.0.0" xml:lang="en-US" xsi:schemaLocation="http://www.opengis.net/ows/1.1 

http://schemas.opengis.net/ows/1.1.0/owsExceptionReport.xsd&quot;&amp;gt;&amp;lt;ows:Exception exceptionCode="OperationProcessingFailed"

locator="mapserv"><ows:ExceptionText>msWFSGetFeature(): WFS server error. FLTApplyFilterToLayer() failed

msPostGISLayerWhichShapes(): Query error. Error executing query. Check server logs</ows:ExceptionText></ows:Exception></ows:ExceptionReport>

Same in WFS 1.1 with 

https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:o

c:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%

t/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gm

tyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyNam

er%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A

3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A

ww.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A

pertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A

/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A

The workaround here is to disable "Only request features overlapping the view extent", but the issue is on the server

#4 - 2019-02-24 04:13 PM - Giovanni Manghi

- Status changed from Open to Closed

Files

21.03.png 58.5 KB 2017-03-21 Stefan Rey
http://schemas.opengis.net/ows/1.1.0/owsExceptionReport.xsd&quot;&amp;gt;&amp;lt;ows:Exception
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
https://wfs.geodienste.ch/av/deu?SERVICE=WFS&#38;REQUEST=GetFeature&#38;VERSION=1.1.0&#38;TYPENAME=SOPT&#38;SRSNAME=urn:ogc:def:crs:EPSG::2056&#38;FILTER=%3Cogc:Filter%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%20xmlns:gml%3D%22http://www.opengis.net/gml%22%3E%0A%20%3Cogc:And%3E%0A%20%20%3Cogc:BBOX%3E%0A%20%20%20%3Cogc:PropertyName%3EmsGeometry%3C/ogc:PropertyName%3E%0A%20%20%20%3Cgml:Envelope%20srsName%3D%22urn:ogc:def:crs:EPSG::2056%22%3E%0A%20%20%20%20%3Cgml:lowerCorner%3E2427790%201059290%3C/gml:lowerCorner%3E%0A%20%20%20%20%3Cgml:upperCorner%3E2886430%201310890%3C/gml:upperCorner%3E%0A%20%20%20%3C/gml:Envelope%3E%0A%20%20%3C/ogc:BBOX%3E%0A%20%20%3Cogc:PropertyIsEqualTo%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3E%0A%20%20%20%3Cogc:PropertyName%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EKanton%3C/ogc:PropertyName%3E%0A%20%20%20%3Cogc:Literal%20xmlns:ogc%3D%22http://www.opengis.net/ogc%22%3EBE%3C/ogc:Literal%3E%0A%20%20%3C/ogc:PropertyIsEqualTo%3E%0A%20%3C/ogc:And%3E%0A%3C/ogc:Filter%3E%0A
